function login(referral) {
    chrome.runtime.sendMessage({
      action: "login",
      data: { ref: referral },
    });
  }
  
  function upgradeToPro() {
    chrome.storage.sync.get("uid", function (data) {
      var userId = data.uid;
      if (!userId) {
        alert("Login First");
      } else {
        var link =
          config.host +
          "/" +
          config.productId +
          "/lp.html?uid=" +
          userId +
          "&successURL=" +
          encodeURIComponent(
            config.host +
              "/gateway.html?t=" +
              encodeURIComponent(chrome.runtime.getURL("/auth/pay/success.html"))
          ) +
          "&canceledURL=" +
          encodeURIComponent(
            config.host +
              "/gateway.html?t=" +
              encodeURIComponent(chrome.runtime.getURL("/auth/pay/fail.html"))
          );
        chrome.tabs.create(
          {
            url: link,
            active: true,
          },
          function (temp) {}
        );
      }
    });
  }
  
  async function getRole(userId) {
    try {
      const response = await fetch(config.host + "/api/profile/", {
        method: "post",
        headers: { "Content-Type": "application/json" },
        body: JSON.stringify({
          product_id: config.productId,
          user_id: userId,
        }),
      });
      if (response.ok) {
        const jsonData = await response.json();
        console.log(jsonData);
        const roleData = jsonData.data || {};
        return (
          chrome.storage.sync.set({ myrole: roleData }, function () {}),
          roleData
        );
      } else {
        const error = "Failed to get role info from server: " + response.status;
        console.log(error);
        const role = {};
        return (
          chrome.storage.sync.set({ myrole: role }, function () {}),
          role
        );
      }
    } catch (e) {
      console.log(e);
    }
    return;
  }
  
  async function roleCheck() {
    var userData = await chrome.storage.sync.get(["uid"]),
      userId = userData.uid;
    if (!userId) {
      alert("Login First");
      const encodedUrl = encodeURIComponent(
        chrome.runtime.getURL(window.location.pathname)
      );
      login(encodedUrl);
      throw new Error("no login");
    } else {
      var userRole = await getRole(userId);
      return console.log("Current role: " + userRole), userRole;
    }
  }
  
  function customerPortal() {
    chrome.storage.sync.get("uid", function (userData) {
      var userId = userData.uid;
      if (!userId) {
        return;
      }
      fetch(config.host + "/api/pay/stripe/customer-portal", {
        method: "post",
        headers: { "Content-Type": "application/json" },
        body: JSON.stringify({
          user_id: userId,
          product_id: config.productId,
          return_url:
            config.host +
            "/gateway.html?t=" +
            encodeURIComponent(chrome.runtime.getURL("/help.html")),
        }),
      })
        .then((response) => response.json())
        .then((responseData) => {
          chrome.tabs.create(
            {
              url: responseData.url,
              active: true,
            },
            function (temp) {}
          );
        })
        .catch((error) => {
          console.log(error);
        });
    });
  }
  
  async function updateUsage(useData) {
    var userData = await chrome.storage.sync.get(["uid"]),
      userId = userData.uid;
    if (!userId) {
      alert("Login First");
      const encodedUrl = encodeURIComponent(
        chrome.runtime.getURL(window.location.pathname)
      );
      login(encodedUrl);
      throw new Error("no login");
    } else {
      try {
        const response = await fetch(config.host + "/api/profile/use", {
          method: "post",
          headers: { "Content-Type": "application/json" },
          body: JSON.stringify({
            product_id: config.productId,
            user_id: userId,
            use: useData,
          }),
        });
        if (response.ok) {
          const jsonData = await response.json();
          console.log(jsonData);
        } else {
          const error = "Failed to update usage: " + response.status;
          console.log(error);
        }
      } catch (error) {
        console.log(error);
      }
    }
  }
  