chrome.runtime.onMessage.addListener(function (message, sender, sendResponse) {
    if (message.action === 'openPage') {
      const data = message.data;
      chrome.storage.local.set({ leads: data }, function () {
        chrome.tabs.create({ url: 'dashboard.html' });
      });
    }
    if (message.action === 'access') {
      return (
        (async () => {
          const url = message.data.url,
            controller = new AbortController(),
            timeoutId = setTimeout(() => {
              controller.abort();
            }, 10000);
          try {
            var parsedUrl = new URL(url);
            const response = await Promise.race([
              fetch('' + url, {
                signal: controller.signal,
                redirect: 'follow',
              }),
              new Promise((resolve, reject) =>
                setTimeout(() => reject(new Error('timeout')), 10000)
              ),
            ]);
            console.log(
              'visit ' +
                url +
                ', ok: ' +
                response.ok +
                ', status: ' +
                response.status
            );
            if (!response.ok) {
              sendResponse('');
              return;
            }
            const body = await response.text();
            sendResponse(body);
          } catch (error) {
            console.log(error);
          } finally {
            clearTimeout(timeoutId);
            sendResponse('');
          }
        })(),
        true
      );
    }
  });
  