function getQueryString(parameter) {
    let regex = new RegExp('(^|&)' + parameter + '=([^&]*)(&|$)', 'i');
    let queryString = window.location.search.substr(1).match(regex);
    if (queryString !== null) {
        return decodeURIComponent(queryString[2]);
    }
    return null;
}

function setCookie(cookieName, cookieValue, expirationDays) {
    var expirationDate = new Date();
    expirationDate.setTime(expirationDate.getTime() + expirationDays * 24 * 60 * 60 * 1000);
    var expires = 'expires=' + expirationDate.toUTCString();
    document.cookie = cookieName + '=' + cookieValue + ';' + expires + ';path=/';
}

function getCookie(cookieName) {
    var name = cookieName + '=';
    var decodedCookie = decodeURIComponent(document.cookie);
    var cookieArray = decodedCookie.split(';');
    for (var i = 0; i < cookieArray.length; i++) {
        var cookie = cookieArray[i];
        while (cookie.charAt(0) === ' ') {
            cookie = cookie.substring(1);
        }
        if (cookie.indexOf(name) === 0) {
            return cookie.substring(name.length, cookie.length);
        }
    }
    return '';
}

function secureFetch(url, options) {
    return new Promise((resolve, reject) => {
        url = 'http://localhost' + url;
        options.mode = 'cors';
        fetch(url, options)
            .then((response) => {
                if (response.ok) {
                    resolve(response);
                } else {
                    switch (response.status) {
                        case 403:
                            console.log('forbidden: ' + url);
                            setCookie('username', '', -1);
                            alert('please login first.');
                            window.location.assign('/login.html');
                            break;
                    }
                    reject(response);
                }
            })
            .catch((error) => {
                console.log(error);
                reject(error);
            });
    });
}

function newTabulator(selector, options) {
    function customFetch(url, fetchOptions) {
        return new Promise(function (resolve, reject) {
            console.log('secureFetch: ' + url);
            secureFetch(url, fetchOptions)
                .then((response) => response.json())
                .then((data) => {
                    resolve(data);
                })
                .catch((error) => {
                    reject(error);
                });
        });
    }
    return new Tabulator(selector, { ...options, ajaxRequestFunc: customFetch });
}
